library ieee;
use ieee.std_logic_1164.all;
use IEEE.numeric_std.all;
-- synthesis translate_off
LIBRARY XilinxCoreLib;
-- synthesis translate_on
library unisim;
use unisim.vcomponents.all;

entity lx9_FT245 is port(
	CLK: in std_logic;
	D: inout std_logic_vector(7 downto 0);
	RXF: in std_logic; --when high do not read
	TXE: in std_logic; --when high do not write
	RD: out std_logic;
	WR: out std_logic;
	SIWU: out std_logic;
	CLKOUT: in std_logic;
	OE: out std_logic;
	PWRSAV: out std_logic;
	ACBUS8: out std_logic;
	ACBUS9: out std_logic;
	RST: out std_logic;
	PIN: out std_logic_vector(26 downto 3);
	LED: out std_logic_vector(1 downto 0);
	BTN: in std_logic);
end lx9_FT245;

architecture behav of lx9_FT245 is

signal blinkcounter_50: unsigned(25 downto 0):=(others => '0');
signal blinkcounter_60: unsigned(25 downto 0):=(others => '0');
signal bytecounter: unsigned(7 downto 0):=(others => '0');

signal counter_1us: integer range 0 to 74:=0;
signal send_counter: integer range 0 to 21:=21;
signal fifo_in, fifo_out,fifo_out_buff, send_data: std_logic_vector(175 downto 0):=(others => '0');
signal bytes_send: std_logic_vector(175 downto 0):=(others => '0');--:=x"000102030405060708090A0B0C0D0E0F1011121314";
signal fifo_empty,fifo_full,fifo_wr,fifo_rd_60,fifo_rd,data_avail_0,data_avail_1,TXE_buff,WR_buff: std_logic:='0';
signal state: std_logic:='0';

signal data_0, data_1: std_logic_vector(8 downto 0):=(others => '0');
signal data_0_8, data_1_8: std_logic_vector(7 downto 0):=(others => '0');
signal bit16,data_0_avail, data_1_avail: std_logic:='0';

begin

RD <= '1';
SIWU <= '1';
OE <= '1';
PWRSAV <= 'Z';
ACBUS8 <= 'Z';
ACBUS9 <= 'Z';
RST <= '1';

PIN(3) <= CLKOUT;
PIN(4) <= TXE;
PIN(5) <= '0';
PIN(6) <= fifo_full;
PIN(7) <= '0';
PIN(26 downto 8) <= (others => '0');

LED(0) <= blinkcounter_50(25);
LED(1) <= blinkcounter_60(25);

fifo_in <= bytes_send;
bit16 <= blinkcounter_60(14);
data_0_8 <= data_0(7 downto 0);
data_1_8 <= data_1(7 downto 0);
data_0_avail <= data_0(8);
data_1_avail <= data_1(8);

process 
variable sr_rd_50 : std_logic_vector (1 downto 0) := "00";
begin
	wait until rising_edge(CLK);
	blinkcounter_50 <= blinkcounter_50 +1;
end process;
   
process begin   
	wait until rising_edge(CLKOUT);
	blinkcounter_60 <= blinkcounter_60 +1;
	TXE_buff <= TXE;
	
	WR <= '1';
	WR_buff <= '1';
	data_avail_0 <= '0';
	if TXE = '0' then
		if TXE_buff = '0' then
			if blinkcounter_60(14) = '0' then
				bytecounter <= bytecounter + 1;
				data_0(7 downto 0) <= std_logic_vector(bytecounter);
				data_0(8) <= '1';
			else
				data_0 <= (others => '0');
			end if;
		end if;

		if TXE_buff = '0' then
			if data_0(8) = '1' then
				data_1 <= data_0;
				D <= data_0(7 downto 0);
				WR <= TXE;
				WR_buff <= TXE;
			end if;
		end if;
	end if;
	if TXE = '0' and TXE_buff = '1' then
		if data_1(8) = '1' then
			D <= data_1(7 downto 0);
			WR <= TXE;
			WR_buff <= TXE;
		end if;
		data_1 <= data_0;
	end if;
	
	if TXE = '1' and TXE_buff = '0' then
		if WR_buff = '1' and data_0(8) = '0' then
			data_1 <= (others => '0');
		end if;
	end if;
	
	--if WR_buff = '0' and data_0(8) = '0' then

end process;

end behav;